unit View.OrderEntryCorrugated;

interface

uses
  System.SysUtils, System.Generics.Collections, System.Classes, JS, Web, WEBLib.Graphics, WEBLib.Controls,
  WEBLib.Forms, WEBLib.Dialogs, WEBLib.Menus, WEBLib.ExtCtrls, WEBLib.StdCtrls,
  WEBLib.JSON, Auth.Service, XData.Web.Client, WebLib.Storage,
  ConnectionModule, App.Types, Vcl.StdCtrls, Vcl.Controls, WEBLib.DBCtrls,
  Data.DB, XData.Web.JsonDataset, XData.Web.Dataset, WEBLib.DB;

type
  TFOrderEntry = class(TWebForm)
    pnlMessage: TWebPanel;
    lblMessage: TWebLabel;
    btnCloseNotification: TWebButton;
    dtpOrderDate: TWebDateTimePicker;
    dtpProofDate: TWebDateTimePicker;
    dtpShipDate: TWebDateTimePicker;
    WebLabel1: TWebLabel;
    WebLabel2: TWebLabel;
    dtpArtDue: TWebDateTimePicker;
    dtpPlateDue: TWebDateTimePicker;
    dtpMountDue: TWebDateTimePicker;
    WebLabel3: TWebLabel;
    WebLabel4: TWebLabel;
    WebLabel5: TWebLabel;
    WebLabel6: TWebLabel;
    WebButton1: TWebButton;
    WebLabel7: TWebLabel;
    dtpApprovedDate: TWebDateTimePicker;
    WebLabel8: TWebLabel;
    WebLabel9: TWebLabel;
    edtCompanyName: TWebDBEdit;
    edtCompanyAccountName: TWebDBEdit;
    edtInQuickBooks: TWebDBEdit;
    edtShipVia: TWebDBEdit;
    edtQuantity: TWebDBEdit;
    edtPrice: TWebDBEdit;
    edtInvoiceTo: TWebDBEdit;
    edtShipTo: TWebDBEdit;
    edtPONumber: TWebDBEdit;
    edtJobName: TWebDBEdit;
    edtQuickBooksItem: TWebDBEdit;
    edtArtLocation: TWebDBEdit;
    edtDimensionalLayout: TWebDBEdit;
    edtEmail: TWebDBEdit;
    edtFTP: TWebDBEdit;
    edtOther: TWebDBEdit;
    edtExistingCuttingDie: TWebDBEdit;
    edtRefArtPrintCard: TWebDBEdit;
    edtRefArtAPDF: TWebDBEdit;
    edtCADFile: TWebDBEdit;
    edtAroundNo: TWebDBEdit;
    edtAcrossNo: TWebDBEdit;
    edtDieCutNo: TWebDBEdit;
    edtRSCD: TWebDBEdit;
    edtRSCW: TWebDBEdit;
    edtRSCL: TWebDBEdit;
    edtCustomAdhesive: TWebDBEdit;
    edtCustomBacking: TWebDBEdit;
    edtStandardSetup: TWebDBEdit;
    edtStripMount: TWebDBEdit;
    edtLoose: TWebDBEdit;
    edtRSCStyle: TWebDBEdit;
    edtProofOther: TWebDBEdit;
    edtProofShipTo: TWebDBEdit;
    edtEmailAttn: TWebDBEdit;
    edtProofEmail: TWebDBEdit;
    edtFaxAttn: TWebDBEdit;
    edtFax: TWebDBEdit;
    edtClemson: TWebDBEdit;
    edtCrossHairs: TWebDBEdit;
    edtMachineIndent: TWebDBEdit;
    edtCylinderSize: TWebDBEdit;
    edtJobNumber: TWebDBEdit;
    edtPlateMaterial: TWebDBEdit;
    edtThickness: TWebDBEdit;
    cbArtApprovedAsIs: TWebDBCheckBox;
    cbPDFFile: TWebDBCheckBox;
    cbWideFormat: TWebDBCheckBox;
    cbPrintCard: TWebDBCheckBox;
    cbFullSizePanel: TWebDBCheckBox;
    cbStripMount: TWebDBCheckBox;
    cbFullMount: TWebDBCheckBox;
    cbStickyBak: TWebDBCheckBox;
    WebDBCheckBox9: TWebDBCheckBox;
    cbExcaliburDie: TWebDBCheckBox;
    cbDiskorCD: TWebDBCheckBox;
    cbSampleCarton: TWebDBCheckBox;
    cbPlate: TWebDBCheckBox;
    cbColorCopy: TWebDBCheckBox;
    cbBWCopy: TWebDBCheckBox;
    XDataWebClient1: TXDataWebClient;
    edtSpecialInstructions: TWebDBEdit;
    tmrScrollTop: TWebTimer;
    XDataWebDataSet1: TXDataWebDataSet;
    WebDataSource1: TWebDataSource;
    XDataWebDataSet1Quantity: TStringField;
    XDataWebDataSet1accountCompanyName: TStringField;
    XDataWebDataSet1acrossNo: TStringField;
    XDataWebDataSet1approvedDate: TStringField;
    XDataWebDataSet1aroundNo: TStringField;
    XDataWebDataSet1artApprovedAsIs: TBooleanField;
    XDataWebDataSet1artDue: TStringField;
    XDataWebDataSet1artLocation: TStringField;
    XDataWebDataSet1bwCopy: TBooleanField;
    XDataWebDataSet1cadFile: TStringField;
    XDataWebDataSet1clemson: TStringField;
    XDataWebDataSet1companyName: TStringField;
    XDataWebDataSet1crossHairs: TIntegerField;
    XDataWebDataSet1customAdhesive: TStringField;
    XDataWebDataSet1customBacking: TStringField;
    XDataWebDataSet1cylinderSize: TStringField;
    XDataWebDataSet1dieCutNo: TStringField;
    XDataWebDataSet1dimensionalLayout: TStringField;
    XDataWebDataSet1diskOrCD: TBooleanField;
    XDataWebDataSet1email: TStringField;
    XDataWebDataSet1emailAttn: TStringField;
    XDataWebDataSet1excaliburDie: TBooleanField;
    XDataWebDataSet1existingCuttingDie: TStringField;
    XDataWebDataSet1fax: TStringField;
    XDataWebDataSet1faxAttn: TStringField;
    XDataWebDataSet1ftp: TStringField;
    XDataWebDataSet1fullMount: TBooleanField;
    XDataWebDataSet1fullSizePanel: TBooleanField;
    XDataWebDataSet1inQuickBooks: TStringField;
    XDataWebDataSet1jobName: TStringField;
    XDataWebDataSet1jobNumber: TStringField;
    XDataWebDataSet1loose: TStringField;
    XDataWebDataSet1machineIdent: TStringField;
    XDataWebDataSet1mountDue: TStringField;
    XDataWebDataSet1orderDate: TStringField;
    XDataWebDataSet1other: TStringField;
    XDataWebDataSet1pdfFile: TBooleanField;
    XDataWebDataSet1plateDue: TStringField;
    XDataWebDataSet1plateMaterial: TStringField;
    XDataWebDataSet1plates: TBooleanField;
    XDataWebDataSet1printCard: TBooleanField;
    XDataWebDataSet1proofDate: TStringField;
    XDataWebDataSet1proofEmail: TStringField;
    XDataWebDataSet1proofOther: TStringField;
    XDataWebDataSet1proofShipTo: TStringField;
    XDataWebDataSet1quickBooksItem: TStringField;
    XDataWebDataSet1refArtPrintCard: TStringField;
    XDataWebDataSet1rscStyle: TStringField;
    XDataWebDataSet1rscd: TStringField;
    XDataWebDataSet1rescl: TStringField;
    XDataWebDataSet1rscw: TStringField;
    XDataWebDataSet1sampleCarton: TBooleanField;
    XDataWebDataSet1shipDate: TStringField;
    XDataWebDataSet1shipTo: TStringField;
    XDataWebDataSet1shipVia: TStringField;
    XDataWebDataSet1specialInstructions: TStringField;
    XDataWebDataSet1standardSetup: TStringField;
    XDataWebDataSet1stickyBak: TBooleanField;
    XDataWebDataSet1stripMount: TStringField;
    XDataWebDataSet1thickness: TStringField;
    XDataWebDataSet1wideFormat: TStringField;
    XDataWebDataSet1price: TStringField;
    XDataWebDataSet1invoiceTo: TStringField;
    XDataWebDataSet1colorCopy: TBooleanField;
    XDataWebDataSet1refArtAPDF: TStringField;
    XDataWebDataSet1poNumber: TStringField;
    XDataWebDataSet1colors: TStringField;
    btnConfirm: TWebButton;
    procedure WebFormCreate(Sender: TObject);
    procedure HideNotification();
    procedure ShowNotification(Notification: string);
    procedure WebFormShow(Sender: TObject);
    [async] procedure getOrder(Order_ID: string);
    procedure tmrScrollTopTimer(Sender: TObject);
    procedure WebButton1Click(Sender: TObject);
    procedure addColorRow(num, Color, LPI, Size: string);
    procedure btnConfirmClick(Sender: TObject);
  private
    FAgencyCode: string;
    FCurrentReportType: string;
    FSelectProc: TSelectProc;
    orderID: string;
    //FJSONProc1: TJSONProc1;
  public
    class function CreateForm(AElementID, orderInfo: string): TWebForm;
  end;

var
  FOrderEntry: TFOrderEntry;

implementation

{$R *.dfm}

uses
  View.Home;

procedure TFOrderEntry.btnConfirmClick(Sender: TObject);
var
  colorList: TList<TJSONObject>;
  container: TJSElement;
  colorCollection: TJSHTMLCollection;
  color: TJSHTMLElement;
  I, J: integer;
  colorJSON: TJSONObject;
  fieldNames: TStringList;
  itemList: TJSNodeList;
  header, value: string;
begin
  //TJSONObject.Create;
  colorList := TList<TJSONObject>.Create;
  container := document.getElementById('additionalFields');
  colorCollection := container.children;
  for I := 0 to colorCollection.length - 1 do
  begin
    colorJSON := TJSONObject.Create;
    itemList := colorCollection[I].childNodes;
    //console.log(itemList.length);
    for J := 0 to itemList.length - 2 do
    begin
      header := TJSHTMLElement(itemList[J]).children[0].innerText.Replace(':', '').Trim();
      value := TJSHTMLInputElement(TJSHTMLElement(itemList[J]).childNodes[1]).value;
      colorJSON.AddPair(header, value);
    end;
    colorList.Add(colorJson);
  end;
  for colorJSON in colorList do
    begin
      console.log(colorJSON.ToString); // Log each JSON object
    end;


  //XDataWebDataSet1.Insert;
  //XDataWebDataSet1colors.AsString := ' ';
  //XDataWebDataSet1.Post;
  {asm
    const container = document.getElementById('additionalFields');
    const rows = container.children;
    const inputData = [];

    for (let i = 0; i < rows.length; i++) {
        const inputs = rows[i].getElementsByTagName('input');
        const rowData = {};

        {for (let j = 0; j < inputs.length; j++) {
            const label = inputs[j].previousElementSibling.textContent.replace(':', '').trim();
            rowData[label] = inputs[j].value;
        }

        {inputData.push(rowData);
    }

    {console.log(inputData);
  end;}

end;

class function TFOrderEntry.CreateForm(AElementID, orderInfo: string): TWebForm;
begin
  Application.CreateForm(TFOrderEntry, AElementID, Result,
    procedure(AForm: TObject)
    begin
      with TFOrderEntry(AForm) do
      begin
        HideNotification;
        TFOrderEntry(AForm).orderID := orderInfo;
      end;
    end
  );

end;

procedure TFOrderEntry.addColorRow(num: string; Color: string; LPI: string; Size: string);
begin
  asm
      const container = document.getElementById('additionalFields');

      // Create a new row for the new fields
      const newRow = document.createElement('div');
      newRow.className = 'row mb-2';

      // Labels and inputs
      const labels = ['#', 'Color', 'LPI', 'Size'];
      const values = [num, Color, LPI, Size];
      labels.forEach((label, index) => {
        const col = document.createElement('div');
        col.className = 'col-sm';

        const labelElement = document.createElement('label');
        labelElement.className = 'pe-2';
        labelElement.style.fontWeight = '700';
        labelElement.style.fontSize = '15px';
        labelElement.textContent = label + ':';

        const inputElement = document.createElement('input');
        inputElement.className = 'form-control input-sm';
        inputElement.style.width = '100%';
        inputElement.id =  'input-' + container.childElementCount + '-' + index; // Unique ID based on count
        inputElement.value = values[index];  // Set the value based on the parameter

        col.appendChild(labelElement);
        col.appendChild(inputElement);

        newRow.appendChild(col);
      });

      const removeButtonCol = document.createElement('div');
      removeButtonCol.className = 'col-auto d-flex align-items-center';

      const removeButton = document.createElement('button');
      removeButton.className = 'btn btn-danger btn-sm';
      removeButton.textContent = 'Remove';
      removeButton.addEventListener('click', function() {
        container.removeChild(newRow);
      });

      removeButtonCol.appendChild(removeButton);
      newRow.appendChild(removeButtonCol);

      // Add the new row to the container
      container.appendChild(newRow);
    end;
end;

procedure TFOrderEntry.WebButton1Click(Sender: TObject);
begin
  addColorRow('','','','');
end;

procedure TFOrderEntry.WebFormCreate(Sender: TObject);
begin
   if not DMConnection.ApiConnection.Connected then
   begin
    DMConnection.ApiConnection.OpenAsync;
    console.log('report requirements connection open')
   end;
end;

procedure TFOrderEntry.getOrder(Order_ID: string);
var
  xdcResponse: TXDataClientResponse;
  orderList : TJSObject;
  i: integer;
  data: TJSArray;
  order: TJSObject;
  callListLength: integer;
  tempString: string;
  colorObject: TJSObject;
  colorList: TJSArray;
  colorLength: integer;
  color: TJSObject;
begin
  xdcResponse := await(XDataWebClient1.RawInvokeAsync('ILookupService.GetOrder',
        [Order_ID]));
    order :=  TJSObject(xdcResponse.Result);
    data := TJSArray(order['data']);
    XDataWebDataSet1.Close;
    XDataWebDataSet1.SetJsonData(order);
    XDataWebDataSet1.Open;
    colorObject := TJSObject(TJSJSON.parse(XDataWebDataSet1colors.Value));
  colorList := TJSArray(colorObject['items']);
  colorLength := colorList.length;
  for i := 0 to colorLength - 1 do
  begin
    color := TJSObject(colorList[i]);
    addColorRow(String(color['#']), string(color['Color']), string(color['LPI']), string(color['Size']));
  end;
  if not (XDataWebDataSet1orderDate.AsString = '') then
    dtpOrderDate.Date := StrToDateTime(XDataWebDataSet1orderDate.Value);
  if not (XDataWebDataSet1proofDate.AsString = '') then
    dtpProofDate.Date := StrToDateTime(XDataWebDataSet1proofDate.Value);
  if not (XDataWebDataSet1shipDate.AsString = '') then
    dtpShipDate.Date := StrToDateTime(XDataWebDataSet1shipDate.Value);
  if not (XDataWebDataSet1artDue.AsString = '') then
    dtpArtDue.Date := StrToDateTime(XDataWebDataSet1artDue.Value);
  if not (XDataWebDataSet1plateDue.AsString = '') then
    dtpPlateDue.Date := StrToDateTime(XDataWebDataSet1plateDue.Value);
  if not (XDataWebDataSet1mountDue.AsString = '') then
    dtpMountDue.Date := StrToDateTime(XDataWebDataSet1mountDue.Value);
  if not (XDataWebDataSet1approvedDate.AsString = '') then
    dtpApprovedDate.Date := StrToDateTime(XDataWebDataSet1approvedDate.Value)
  else
    dtpApprovedDate.Date := Now;
end;

procedure TFOrderEntry.WebFormShow(Sender: TObject);
begin
  getOrder(orderID);
end;

procedure TFOrderEntry.HideNotification;
begin
  pnlMessage.ElementHandle.hidden := True;
end;

procedure TFOrderEntry.ShowNotification(Notification: string);
begin
  if Notification <> '' then
  begin
    lblMessage.Caption := Notification;
    pnlMessage.ElementHandle.hidden := False;
  end;
end;


procedure TFOrderEntry.tmrScrollTopTimer(Sender: TObject);
begin
  tmrScrollTop.Enabled := False;
  window.scrollTo(0, 0);
end;

initialization
  RegisterClass(TFOrderEntry);

end.

